//
// @author    ICT専門学校 システム開発実践科 4期生 1年 高橋 利政
// @date    2019/01/23
// @update    2019/xx/xx
//

#include "misc.h"

#include <time.h>

#include "map.h"
#include "time.h"
#include "gameType.h"
#include "nextStage.h"

typedef struct {
    GmType type;
    GmType (*pGamen)();
}Gamen;

static const Gamen kGamen[] = {
    { GM_START, startDisplay },
    { GM_GAME , gameDisplay },
    { GM_MENU , menuDisplay },
    { GM_HELP , helpDisplay },
    { GM_END , endGameDisplay },
    { GM_CLEAR , gameClearedDisplay },
    { GM_STAGECLEAR, NextStageDisplay },
    { GM_TIMEOVER , timeOverDisplay },
};

int main()
{
    GmType displayType = GM_START;
    int i;
    
    // 初期化する
    srand((unsigned int)time(NULL));
    setupMap();
    setupTime();
    
    while (displayType != GM_EXIT) {
        // 画面初期化
        myCls();    // 画面消去

        // 画面切り替え
        for (i = 0; i < ARRAYOF(kGamen); i++) {
            if (displayType == kGamen[i].type) {
                displayType = (*kGamen[i].pGamen)();
                break;
            }
        }
    }
    
    return 0;
}

