#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <fcntl.h>

#include "misc.h"
#include "porting.h"

//
// getch()、kbhit()関数の移植において、peroon's diary様の「コンソール・ゲーム C言語 getch kbhit linux」から流用させて頂きました。
// http://peroon.hatenablog.com/entry/20110730/1311996770
//

int mygetch() {
  struct termios oldt,
                 newt;
  int            ch;

  tcgetattr( STDIN_FILENO, &oldt );
  newt = oldt;
  newt.c_lflag &= ~( ICANON | ECHO );
  tcsetattr( STDIN_FILENO, TCSANOW, &newt );
  ch = getchar();
  tcsetattr( STDIN_FILENO, TCSANOW, &oldt );
  return ch;
}

int mykbhit()
{
  struct termios oldt, newt;
  int ch;
  int oldf;

  tcgetattr(STDIN_FILENO, &oldt);
  newt = oldt;
  newt.c_lflag &= ~(ICANON | ECHO);
  tcsetattr(STDIN_FILENO, TCSANOW, &newt);
  oldf = fcntl(STDIN_FILENO, F_GETFL, 0);
  fcntl(STDIN_FILENO, F_SETFL, oldf | O_NONBLOCK);

  ch = getchar();

  tcsetattr(STDIN_FILENO, TCSANOW, &oldt);
  fcntl(STDIN_FILENO, F_SETFL, oldf);

  if(ch != EOF)
  {
    ungetc(ch, stdin);
    return 1;
  }

  return 0;
}

// 画面消去
void myCls() {
    system("clear");
}

// カーソルを1文字分進める
void myCursorRight() {
    printf("\x1b[1C");
}

// カーソルから後ろを消す
void myCursorClear() {
    printf("\x1b[0J");
}
